/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-scheduler-msgs-0.6.9-0precise-20150328-0751/msg/Resource.msg
 *
 */


#ifndef SCHEDULER_MSGS_MESSAGE_RESOURCE_H
#define SCHEDULER_MSGS_MESSAGE_RESOURCE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <uuid_msgs/UniqueID.h>
#include <rocon_std_msgs/Remapping.h>

namespace scheduler_msgs
{
template <class ContainerAllocator>
struct Resource_
{
  typedef Resource_<ContainerAllocator> Type;

  Resource_()
    : rapp()
    , id()
    , uri()
    , remappings()  {
    }
  Resource_(const ContainerAllocator& _alloc)
    : rapp(_alloc)
    , id(_alloc)
    , uri(_alloc)
    , remappings(_alloc)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _rapp_type;
  _rapp_type rapp;

   typedef  ::uuid_msgs::UniqueID_<ContainerAllocator>  _id_type;
  _id_type id;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _uri_type;
  _uri_type uri;

   typedef std::vector< ::rocon_std_msgs::Remapping_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::rocon_std_msgs::Remapping_<ContainerAllocator> >::other >  _remappings_type;
  _remappings_type remappings;




  typedef boost::shared_ptr< ::scheduler_msgs::Resource_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::scheduler_msgs::Resource_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct Resource_

typedef ::scheduler_msgs::Resource_<std::allocator<void> > Resource;

typedef boost::shared_ptr< ::scheduler_msgs::Resource > ResourcePtr;
typedef boost::shared_ptr< ::scheduler_msgs::Resource const> ResourceConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::scheduler_msgs::Resource_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::scheduler_msgs::Resource_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace scheduler_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'rocon_std_msgs': ['/opt/ros/hydro/share/rocon_std_msgs/cmake/../msg'], 'rocon_service_pair_msgs': ['/opt/ros/hydro/share/rocon_service_pair_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'scheduler_msgs': ['/tmp/buildd/ros-hydro-scheduler-msgs-0.6.9-0precise-20150328-0751/msg'], 'uuid_msgs': ['/opt/ros/hydro/share/uuid_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::scheduler_msgs::Resource_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::scheduler_msgs::Resource_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::scheduler_msgs::Resource_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::scheduler_msgs::Resource_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::scheduler_msgs::Resource_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::scheduler_msgs::Resource_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::scheduler_msgs::Resource_<ContainerAllocator> >
{
  static const char* value()
  {
    return "1234649cb96e9fac93f446b07c558b23";
  }

  static const char* value(const ::scheduler_msgs::Resource_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x1234649cb96e9facULL;
  static const uint64_t static_value2 = 0x93f446b07c558b23ULL;
};

template<class ContainerAllocator>
struct DataType< ::scheduler_msgs::Resource_<ContainerAllocator> >
{
  static const char* value()
  {
    return "scheduler_msgs/Resource";
  }

  static const char* value(const ::scheduler_msgs::Resource_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::scheduler_msgs::Resource_<ContainerAllocator> >
{
  static const char* value()
  {
    return "### ROCON resource request or response.\n\
#\n\
#   A scheduler_msgs/Request message includes one Resource message for\n\
#   each desired resource.  The scheduler responds using this same\n\
#   message to identify exactly what corresponding resource it has\n\
#   granted.\n\
\n\
# This is usually a uniquely identifying ros_package/rapp name\n\
# identifier, which is unique because ros packages are unique.\n\
string rapp\n\
\n\
# Unique identifier assigned by the requester to track resources\n\
# assigned in the scheduler feedback.\n\
uuid_msgs/UniqueID id\n\
\n\
# Uniform Resource Identifier for the platform.  ROCON defines two\n\
# kinds of URI strings:\n\
#\n\
# 1) A \"resource description URI\" is a canonical string for a specific\n\
#    device.  All components are fully resolved to their most specific\n\
#    values, like:\n\
#\n\
#      \"rocon:/turtlebot/dude3/hydro/precise\"\n\
#\n\
#    The scheduler provides fully resolved resource description URIs\n\
#    in its feedback for requests that have been granted.\n\
#\n\
# 2) A \"request URI\" may provide a similar descriptive representation,\n\
#    or may include patterns for matching multiple alternative\n\
#    platforms.  Omitted or '*' patterns match any valid value:\n\
#\n\
#      \"\"                               # (empty string): any platform\n\
#      \"rocon:/turtlebot\"               # any turtlebot\n\
#      \"rocon:/(turtlebot|segbot)\"      # any robot of either type\n\
#      \"rocon:/*/dude3\"                 # any device named dude3\n\
#      \"rocon:/*/*/ros/ubuntu\"          # any ROS Ubuntu platform\n\
#\n\
string uri\n\
\n\
# Remappings which get passed on for starting the rapps. Also potentially for\n\
# more esoteric use cases such as checking whether an app is sharable.\n\
rocon_std_msgs/Remapping[] remappings\n\
\n\
\n\
================================================================================\n\
MSG: uuid_msgs/UniqueID\n\
# A universally unique identifier (UUID).\n\
#\n\
#  http://en.wikipedia.org/wiki/Universally_unique_identifier\n\
#  http://tools.ietf.org/html/rfc4122.html\n\
\n\
uint8[16] uuid\n\
\n\
================================================================================\n\
MSG: rocon_std_msgs/Remapping\n\
# Describes your typical ros remapping\n\
\n\
string remap_from\n\
string remap_to\n\
";
  }

  static const char* value(const ::scheduler_msgs::Resource_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::scheduler_msgs::Resource_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.rapp);
      stream.next(m.id);
      stream.next(m.uri);
      stream.next(m.remappings);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct Resource_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::scheduler_msgs::Resource_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::scheduler_msgs::Resource_<ContainerAllocator>& v)
  {
    s << indent << "rapp: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.rapp);
    s << indent << "id: ";
    s << std::endl;
    Printer< ::uuid_msgs::UniqueID_<ContainerAllocator> >::stream(s, indent + "  ", v.id);
    s << indent << "uri: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.uri);
    s << indent << "remappings[]" << std::endl;
    for (size_t i = 0; i < v.remappings.size(); ++i)
    {
      s << indent << "  remappings[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::rocon_std_msgs::Remapping_<ContainerAllocator> >::stream(s, indent + "    ", v.remappings[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // SCHEDULER_MSGS_MESSAGE_RESOURCE_H
